## picotool 2.2.0-a4+dfsg

=== debian/changelog ===
picotool (2.2.0-a4+dfsg-2) unstable; urgency=medium

  * bump because of botched dgit push (flaky internet)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Thu, 11 Sep 2025 10:51:10 +0200

picotool (2.2.0-a4+dfsg-1) unstable; urgency=medium

  * New upstream version 2.2.0-a4+dfsg
     - debian/picotool.install: upstream changed
       udev/99-picotool.rules -> udev/60-picotool.rules
  * generate man pages for all subcommands from help output (Closes: #1108840)
  * debian/copyright: remove enc_bootloader.elf
  * debian/source/lintian-overrides: remove unused override
  * debian/salsa-ci.yml: enable cross builds
  * debian/patches: add cross.patch
  * debian/rules:
     - add more blhc ignore rules for targets compiled with arm-none-eabi-gcc
     - disable dh_dwz and dh_strip for /usr/share/picotool/enc_bootloader.elf
  * debian/control: bump pico-sdk version to 2.2.0
  * debian/picotool.lintian-overrides: add overrides for
    /usr/share/picotool/enc_bootloader.elf
  * Add patch disabling --print-memory-usage when linking (otherwise the
    linker output will be in the middle of a cmake log line and break blhc)
  * Build with --no-parallel for linear build logs (for blhc)
  * Added-AppStream-metainfo-XML-with-hardware-provide-i.patch: component id
    must have a .desktop suffix

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Wed, 10 Sep 2025 17:31:25 +0200
