=== debian/tests/control ===
# This test is not in pico-sdk because releases of picotool and pico-sdk happen
# in tandem. When both packages release a new version, building picotool
# requires an equally new pico-sdk. The autokpgtest requires both packages to
# be at their latest version. If this test were in pico-sdk, then we would
# have to upload pico-sdk with a failing autopkgtest because picotool is still
# too old.
# So instead, we put this test into picotool and now we can first upload a new
# pico-sdk (without an autopkgtest) and then a new picotool once pico-sdk is
# in the archive.
Tests:
 hello-world,
Depends:
 build-essential,
 pico-sdk-source (>= 2.1.0),
 picotool,
Restrictions:
 allow-stderr,
